﻿using System;
using System.Windows.Forms;

namespace NEUSB_Sample
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

        }


        private async void button1_Click(object sender, EventArgs e)
        {
            int seq = 0;
            int result = 0;

            /* Connection */
            result = NeUsbController.NeUsbController.NE_OpenDevice();
            if (result != 0)
            {
                textBox1.Text += $"Unable to open device. Please check that it is connected.{Environment.NewLine}";
                return;
            }
            else
            {
                textBox1.Text += $"Sucseeded to open device.{Environment.NewLine}";
            }
            button1.Enabled = false;

            for (int i = 0; i < 3; i++)
            {
                for (seq = 0; seq < 7; seq++)
                {
                    if (result < 0) break;

                    switch (seq)
                    {
                        case 0:
                            result = NeUsbController.NeUsbController.NE_SetLight(NeUsbController.LEDColors.Red, NeUsbController.LEDPatterns.Continuous);
                            break;
                        case 1:
                            result = NeUsbController.NeUsbController.NE_SetLight(NeUsbController.LEDColors.Green, NeUsbController.LEDPatterns.Continuous);
                            break;
                        case 2:
                            result = NeUsbController.NeUsbController.NE_SetLight(NeUsbController.LEDColors.Amber, NeUsbController.LEDPatterns.Continuous);
                            break;
                        case 3:
                            result = NeUsbController.NeUsbController.NE_SetLight(NeUsbController.LEDColors.Blue, NeUsbController.LEDPatterns.Continuous);
                            break;
                        case 4:
                            result = NeUsbController.NeUsbController.NE_SetLight(NeUsbController.LEDColors.Purple, NeUsbController.LEDPatterns.Continuous);
                            break;
                        case 5:
                            result = NeUsbController.NeUsbController.NE_SetLight(NeUsbController.LEDColors.Cyan, NeUsbController.LEDPatterns.Continuous);
                            break;
                        case 6:
                            result = NeUsbController.NeUsbController.NE_SetLight(NeUsbController.LEDColors.Clear, NeUsbController.LEDPatterns.Continuous);
                            break;
                        default:
                            break;
                    }

                    if (result < 0)
                    {
                        textBox1.Text += $"SetLight failed, return {result}, the handle will be destroied.{Environment.NewLine}";
                        break;
                    }
                    await System.Threading.Tasks.Task.Delay(3000);
                }

                for (seq = 0; seq < 8; seq++)
                {
                    if (result < 0) break;

                    switch (seq)
                    {
                        case 0:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.Continuous, 10, 0);
                            break;
                        case 1:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.Pattern1, 10, 0);
                            break;
                        case 2:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.Pattern2, 10, 0);
                            break;
                        case 3:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.Pattern3, 10, 0);
                            break;
                        case 4:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.Pattern4, 10, 0);
                            break;
                        case 5:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.Pattern5, 10, 0);
                            break;
                        case 6:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.Pattern6, 10, 0);
                            break;
                        default:
                            result = NeUsbController.NeUsbController.NE_SetBuz(NeUsbController.BuzzerPatterns.OFF, 0, 0);
                            break;
                    }

                    if (result < 0)
                    {
                        textBox1.Text += $"SetBuzzer failed, return {result}, the handle will be destroied.{Environment.NewLine}";
                        break;
                    }
                    await System.Threading.Tasks.Task.Delay(3000);
                }
            }

            if (!(result < 0))
            {
                result = NeUsbController.NeUsbController.NE_CloseDevice();
                textBox1.Text += $"Sucseeded to close device.{Environment.NewLine}";

            }
            button1.Enabled = true;
        }

    }
}
